



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>.NET平台上插拔姿势的AOP</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">.NET平台上插拔姿势的AOP</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 21:17:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>AOP概述</h2>
<p>AOP技术的诞生并不算晚，早在1990年开始，来自Xerox Palo Alto Research Lab（即PARC）的研究人员就对面向对象思想的局限性进行了分析。他们研究出了一种新的编程思想，借助这一思想或许可以通过减少代码重复模块从而帮助开发人员提高工作效率。随着研究的逐渐深入，AOP也逐渐发展成一套完整的程序设计思想，各种应用AOP的技术也应运而生。</p>
<p>AOP技术在Java平台下是最先得到应用的。就在PARC对于面向方面编程进行研究的同时，美国Northeastern University的博士生Cristina Lopes和其同事也开始了类似的思考。最终，美国国防先进技术研究计划署（Defense Advanced Research Projects Agency即DARPA）注意到了这项工作，并提供了科研经费，鼓励将二者的工作成果结合起来。他们通过定义一套Java语言的扩展系统，使开发者可以方便的进行面向方面的开发，这套扩展系统被称为AspectJ。之后，AspectJ在2002年被转让给Eclipse Foundation，从而成为在开源社区中AOP技术的先锋，也是目前最为流行的AOP工具。</p>
<p>AOP（Aspect-Oriented Programming，面向切面的编程），它是可以通过预编译方式和运行期动态代理实现在不修改源代码的情况下给程序动态统一添加功能的一种技术。它是一种新的方法论，它是对传统OOP编程的一种补充。OOP是关注将需求功能划分为不同的并且相对独立，封装良好的类，并让它们有着属于自己的行为，依靠继承和多态等来定义彼此的关系；AOP是希望能够将通用需求功能从不相关的类当中分离出来，能够使得很多类共享一个行为，一旦发生变化，不必修改很多类，而只需要修改这个行为即可。AOP是使用切面（aspect）将横切关注点模块化，OOP是使用类将状态和行为模块化。在OOP的世界中，程序都是通过类和接口组织的，使用它们实现程序的核心业务逻辑是十分合适。但是对于实现横切关注点（跨越应用程序多个模块的功能需求）则十分吃力，比如日志记录，权限验证，异常拦截等。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/147125/201608/147125-20160812150043515-145240599.png" /></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/147125/201608/147125-20160812150105578-648769313.png" /></p>
<h2>Spring.NET 中的 AOP</h2>
<div>
<p>通知（Advice）: 通知描述了切面要完成的任务，同时还描述了何时执行这个任务。</p>
<p>连接点（Joinpoint）:&nbsp; 程序中应用通知的地方称为连接点，这个点可以是方法被调用时，异常抛出时，甚至访问属性的时候。</p>
<p>切入点（Pointcut）: 切入点定义通知切入的一个或者多个连接点。</p>
<p>切面（Aspect）: 切面就是通知和切入点的结合。通知和切入点共同定义了切面的全部内容：功能、时机、位置。</p>
<p>引入（Introduction）: 允许我们想现有类中增加属性和方法.</p>
<p>目标（Target）: 被通知的对象</p>
<p>代理（Porxy）: 向目标对象增加通知之后，创建的对象，由这个对象来访问实际的目标对象。</p>
<p>织入（Weaving）: 被切面应用到目标对象来创建新的代理对象的过程。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/147125/201608/147125-20160812150359843-1808878159.png" /></p>
<p>配置型 ? &nbsp;no,这不是我需要的太麻烦了。对于新手瞬间懵逼了好吗？</p>
<h2>PostSharp</h2>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/147125/201608/147125-20160812151201843-1976525010.png" /></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/147125/201608/147125-20160812154449031-1650510258.png" /></p>
<p>传送地址 -&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt; &nbsp;<a href="http://www.cnblogs.com/leoo2sk/archive/2010/11/30/aop-postsharp.html" rel="external nofollow noreferrer">http://www.cnblogs.com/leoo2sk/archive/2010/11/30/aop-postsharp.html</a></p>
<p>我们看这个AOP , 发现挺适合的......最后MDZZ,收费.收费的，收费的搞毛线啊~~~~~</p>
<h2>推荐新手的AOP</h2>
<h2><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/147125/201608/147125-20160812151712593-468051692.png" /></h2>
<p>TM逗我?&nbsp;just like PostSharp, but free as in free beer :和PostSharp 一样,但胜在免费。是不是爱上我了？嘿嘿，爱上作者去吧。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/147125/201608/147125-20160812152659921-1661437716.png" /></p>
<p>Nuget：上安装这个，看清楚了呀，等会又来说，诶哟，楼主MDZZ不行啊！</p>
<h2>示列:</h2>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/147125/201608/147125-20160812153024140-1967199156.png" /></p>
<p><a href="https://github.com/ArxOne/MrAdvice" rel="external nofollow noreferrer">开源地址----没看错,作者开源了</a></p>
<h2>感觉属性不够 ? &nbsp;进阶者的AOP --作者也开源了^.^</h2>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/147125/201608/147125-20160812153535187-1606541108.png" /></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/147125/201608/147125-20160812154018062-1980057658.png" /></p>
<p>SheepAspect :<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/147125/201608/147125-20160812154030281-884009745.png" />&nbsp;<a href="https://hendryluk.wordpress.com/2011/05/09/sheepaop-part-2-pointcut-and-saql-basics/" rel="external nofollow noreferrer">SAQL</a>寻找方法规则</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2k6exq.html">使用expect scp避免直接输密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e03emq.html">destoon二次开发基础代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql55xx8.html">centos6&period;5安装lnmp环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxg4l09.html">ANSI&lowbar;NULLS、QUOTED&lowbar;IDENTIFIER</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gowd0q.html">jQuery Validate 表单验证插件----在class属性中添加校验规则进行简单的校验</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0nmk4q.html">&lbrack;Papers&rsqb;NSE&comma; &dollar;u&dollar;&comma; Lorentz space &lbrack;Sohr&comma; JEE&comma; 2001&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1nev79.html">C&plus;&plus;100款开源界面库&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vkoxn8.html">iOS sharedSDK详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x1dez8.html">Linux查看系统资源占用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn7lez8.html">&period;NET基础拾遗（5）反射1</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1w3w79.html">ADO&period;NET入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd7wgr8.html">R与数据分析旧笔记（三）不知道取什么题目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jdm2w8.html">python笔记之列表与元组函数和方法使用举例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy110ngq.html">有一个NSStirng类型，retain时尚宣言name财产setter内部方法的每一行代码的作用&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jk50x8.html">Amazon才推众包物流，&OpenCurlyDoubleQuote;京东众包&rdquo;已红绿上阵，&OpenCurlyDoubleQuote;达达&rdquo;还手握10万配送大军</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7vj69.html">MySQL慢查询&amp;amp&semi;执行计划</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjre6k8.html">关于Linux目录结构的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g05meq.html">初入pygame&mdash;&mdash;贪吃蛇</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyv30d9.html">iview render bug &amp;amp&semi; vue namespace bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gj2dmq.html">phpMyAdmin 安装教程全攻略</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/4qnvl28r.html">UWP开发之Mvvmlight实践八：为什么事件注销处理要写在OnNavigatingFrom中</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m25pqk.html">Kooboo CMS技术文档之二：Kooboo CMS的安装步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kov5qj.html">JQuery（2）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zkex8y.html">c&num;语言规范</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnn3kqr.html">基于fis3的组件可视化道路</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7lgg8e.html">&lowbar;&lowbar;Block与&lowbar;&lowbar;Weak区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e5wx81.html">茂名石化BPM应用实践 &mdash;&mdash;业务协同及服务共享平台建设和应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqln4x8o.html">Android（安卓）-------CardView</a>
			</li>
						<li><a href="https://www.batexi.com/a/m965rjq4.html">linux下 lvm 磁盘扩容</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1j7zqg.html">LVM基本介绍与常用命令</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
